Subject: Add a feature for replacing "new" with "getComponent" in php source files
Description

The AOP Framework should have a feature (which can be enabled through the Component configuration) which results in parsing the
php source files and replace the new operator with a getComponent call. These modified files should be written into the FileCache and
the modified classes used as the parent class for AOP proxies or, if no such proxy exists, registered as the implementation class of
the component with that class name.

History
#1 - 2007-05-04 23:02 - Sudara Williams -

I'm excited by this feature, especially as the default.

It is these kinds of features that really make a framework powerful - doing the heavy lifting in the background and providing a simple and intuitive API
for the developers.

#2 - 2007-07-27 07:50 - Robert Lemke

I implemented this feature but after a discussion with Karsten removed it again - at least disabled it by default. I suggest we make it configurable in the
Components configuration so it's easy to integrate legacy PHP code.

source:/Packages/Framework/Classes/Component/T3P_Framework_Component_ClassFileManipulator.php#257

#3 - 2007-12-06 17:13 - Robert Lemke
- Status changed from New to Accepted

Currently this feature does not work and is disabled. Don't forget to either fix or remove it ...

#4 - 2008-01-08 18:55 - Malte Jansen

Note:
The TYPO3CGL validates the Code in the main folder 'Classes' for 'new'.
'new' will be only allowed, if a component is not registered (e.g. PHPUnit or PHP_CodeSniffer).
The folder 'Resources/PHP/' will be ignored.

It's still needs to be discussed, if a Package can be released/published on the TER.
So everybody could be forced to use to CM.
#5 - 2008-06-25 00:57 - Malte Jansen

Notice: 
The ComponentManager does not know the classes provided by PHP.
e.g. ArrayObject()

#6 - 2008-07-01 15:35 - Robert Lemke
- Target version deleted (1)

#7 - 2008-10-22 23:08 - Robert Lemke
- Status changed from Accepted to Closed

This feature is postponed for now as we probably find a better solution with spl_factory_register()
